"use strict";
// The MIT License (MIT)
//
// Copyright (c) 2020 The Prometheus Authors
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in all
// copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.
Object.defineProperty(exports, "__esModule", { value: true });
const client_1 = require("./lsp/client");
const lsp_1 = require("./lsp");
const hybrid_1 = require("./hybrid");
const client_2 = require("./prometheus/client");
function newCompleteStrategy(conf) {
    var _a, _b, _c, _d, _e;
    if (conf.enableLSP) {
        return new lsp_1.LSPComplete(new client_1.LSPClient(conf.url, conf.httpErrorHandler));
    }
    if (conf.offline) {
        return new hybrid_1.HybridComplete(null, (_a = conf.hybrid) === null || _a === void 0 ? void 0 : _a.fuzzyPre, (_b = conf.hybrid) === null || _b === void 0 ? void 0 : _b.fuzzyPost);
    }
    return new hybrid_1.HybridComplete(new client_2.PrometheusClient(conf.url, conf.httpErrorHandler, (_c = conf.hybrid) === null || _c === void 0 ? void 0 : _c.lookbackInterval), (_d = conf.hybrid) === null || _d === void 0 ? void 0 : _d.fuzzyPre, (_e = conf.hybrid) === null || _e === void 0 ? void 0 : _e.fuzzyPost);
}
exports.newCompleteStrategy = newCompleteStrategy;
//# sourceMappingURL=index.js.map